<?php
/**
 * The template for displaying singular post-types: posts, pages and user-defined custom post types.
 *
 * @package HelloElementor
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

while ( have_posts() ) : the_post();


// Outputs custom HTML for Knowledge Base Article Post type
if( $post->post_type === 'epkb_post_type_1' ){ ?>
	<div class="kb-highlight-custom-code">
		<h1>Custom template</h1>
		<p>Article Template for Current Theme option</p>
	</div>

	<main <?php post_class( 'site-main' ); ?> role="main">
		<?php if ( apply_filters( 'hello_elementor_page_title', true ) ) : ?>
			<header class="page-header">
				<?php the_title( '<h1 class="entry-title">', '</h1>' ); ?>
			</header>
		<?php endif; ?>
		<div class="page-content">
			<h1 class="kb-highlight-custom-code">Example #1: Before all KB content</h1>
			<?php the_content(); ?>
			<h1 class="kb-highlight-custom-code">Example #2: After KB content</h1>
			<div class="post-tags">
				<?php the_tags( '<span class="tag-links">' . __( 'Tagged ', 'hello-elementor' ), null, '</span>' ); ?>
			</div>
			<?php wp_link_pages(); ?>
		</div>

		<?php comments_template(); ?>
	</main>

<?php }else { ?>

<main <?php post_class( 'site-main' ); ?> role="main">
	<?php if ( apply_filters( 'hello_elementor_page_title', true ) ) : ?>
		<header class="page-header">
			<?php the_title( '<h1 class="entry-title">', '</h1>' ); ?>
		</header>
	<?php endif; ?>
	<div class="page-content">

		<?php the_content(); ?>

		<div class="post-tags">
			<?php the_tags( '<span class="tag-links">' . __( 'Tagged ', 'hello-elementor' ), null, '</span>' ); ?>
		</div>
		<?php wp_link_pages(); ?>
	</div>

	<?php comments_template(); ?>
</main>

	<?php

}
endwhile;